<?php

namespace Hp\Test;

use DateTimeImmutable;
use DateTime;
use DateInterval;
use DatePeriod;

class Functions {
    /**
    * Выполняет сортировку массива по убыванию цены  *  
    * @param array $array  *  
    * @return array  
    */ 

    function sortPrice(array $array): array {
        array_multisort(array_column($array, 'price'), SORT_DESC, array_column($array, 'count'), SORT_ASC, $array);
        return $array;
    }

    //На выход должна вернуть отсортированный массив по ключу *price* DESC и во вторую очередь по *count* ASC:

    //[ ['price'=>12, 'count'=>4],  ['price'=>10, 'count'=>2],  ['price'=>8, 'count'=>4],  ['price'=>8, 'count'=>5],  ['price'=>5, 'count'=>5], ]


    /* Найдет элемент с указаным id  *  
    * @param array $array - массив, содержащий элементы со структурой  * 
    [  
        * 'id' => 30,  *      
        'name' => 'Jhon',  *      
        'age' => 23,  * 
    ]  
    * @param $id - ид искомого элемента  *  
    * @return array - найденный элемент   
    */ 
    function search($array, $id): ?array {
        $rowId = array_search($id, array_column($array, 'id'));
        return $array[$rowId];
    }

    /** 
     * Удалить дубликаты, оставив только уникальные значения    
     * @param array $array    
     * @return array  
     */ 

    function uniqElements(array $array): array {
        return array_unique($array, SORT_REGULAR);
    }  

    //Выходной массив: 
    /** Array (
     *   [0] => Array([0] => laravel, [1] => php)
     *   [1] => Array([0] => codeigniter, [1] => php)
     *   [3] => Array([0] => c++, [1] => java)) 
     * )
    */  
}

